#include "msgClient.hh"

using namespace std;

msgClient::msgClient() {}

msgClient::~msgClient() {}

bool msgClient::connect(string name, string server, unsigned int port) {
	this->isconnected = client.connect(server.c_str(), port);
	if(this->isconnected) {
		this->client.subscribe(name.c_str());
		this->name = name;
		this->s_name = server;
		this->s_port = port;
	}
	return this->isconnected;
}

void msgClient::disconnect() {
	this->isconnected = false;
	client.disconnect();
}

bool msgClient::isConnected() {
	return this->isconnected;
} 

bool msgClient::sendMessage(std::string dest, std::string content) { 
	if(this->isConnected()) {
		message msg;
		msg.encode(dest.c_str(), content.c_str());
		return client.send(msg);
	}
	return false;
}

bool msgClient::isMessageWaiting() {
	if(this->isConnected()) {
		return client.checkReadSocket(0);
	}
	return false;
}

pair<string, string> msgClient::getMessage() {
	if(this->isConnected()) {
		int error = 0;
		message msg = client.receive(error);
		if(error) this->isconnected = false;
		else return make_pair(msg.getStringHead(), msg.getStringBody()); 
	}
	return make_pair("", STATUS_DISCONNECTED);
}

pair<string, string> msgClient::getBlockingMessage() {
	if(this->isConnected()) {
		if(client.checkReadSocket(-1)) return this->getMessage();
	}
	return make_pair("", STATUS_DISCONNECTED);
}

