#ifndef MSGSERVER_HH
#define MSGSERVER_HH

#include <map>

#include "iserver.hh"
#include "message.hh"
#include "msgConstants.hh"

class msgServer {

	private:
		iserver iserv;
		unsigned int currentPort;
		bool isRunning;
		bool isMessagesWaiting;
		unsigned int inactivity_time;
		std::map<int, std::string> clientsById;
		std::map<std::string, int> clientsByName;
		
	public:
		msgServer(unsigned int port = DEFAULT_SERVER_PORT, unsigned int inact = DEFAULT_SERVER_INACTIVITY_TIME);
		~msgServer();
		void run();
		void addConnection(int c, std::string n);
		void removeConnection(int c);
		void setInactivityTime(unsigned int inact);
		bool isConnected(std::string c);
		void manageIncomingMessage(int c, message m);
		void sendTo(std::string dest, std::string m);
		void shutdown();
		
};

#endif
